create_clock -name refclk -period 8 [get_ports gtx_refclk_n]

# init_clk is expected to be 125 MHz. For a different clock, update:
# (1) The create_clock constraint below
# (2) The init_clk_freq parameter in the xillydemo module
# (3) The DRP clock frequency in the Transceiver Wizard
#
create_clock -name initclk -period 8 [get_ports init_clk_n]
#
# Pin-pointing pipe_clk and pipe_rx_clk by the registers they're driving
# rather than their source elements, since these sources are generated by
# the IP's Wizard with identifiers that may change across versions.
#
set_clock_groups -asynchronous \
    -group [get_clocks -include_generated_clocks -of_objects [get_ports init_clk_n]] \
    -group [get_clocks -of_objects [ get_pins -hier -filter { name =~ */align_rx_ins/wr_toggle*/C} ] ] \
    -group [get_clocks -of_objects [ get_pins -hier -filter { name =~ */align_rx_ins/rd_toggle*/C} ] ]

# Use SFP0 GTH channel (P5 on board)
set_property LOC GTHE3_CHANNEL_X0Y10 [get_cells -hier -filter { name =~ */ultrascale_frontend_ins/* && ref_name =~ GT*_CHANNEL }]

set_property PACKAGE_PIN M6 [get_ports gtx_refclk_p];
set_property PACKAGE_PIN M5 [get_ports gtx_refclk_n];

set_property PACKAGE_PIN AP8 [get_ports "gpio_led[0]"];
set_property PACKAGE_PIN H23 [get_ports "gpio_led[1]"];
set_property PACKAGE_PIN P20 [get_ports "gpio_led[2]"];
set_property PACKAGE_PIN P21 [get_ports "gpio_led[3]"];
set_property PACKAGE_PIN N22 [get_ports "gpio_led[4]"];
set_property PACKAGE_PIN M22 [get_ports "gpio_led[5]"];
set_property PACKAGE_PIN R23 [get_ports "gpio_led[6]"];
set_property PACKAGE_PIN P23 [get_ports "gpio_led[7]"];

set_property IOSTANDARD LVCMOS18 [get_ports "gpio_led[*]"]
set_false_path -to [get_ports -filter {NAME=~gpio_led*}]

# Reference clock control
set_property -dict { PACKAGE_PIN F10 IOSTANDARD LVDS } [get_ports "init_clk_n"];
set_property -dict { PACKAGE_PIN G10 IOSTANDARD LVDS } [get_ports "init_clk_p"];
set_property -dict { PACKAGE_PIN J24 IOSTANDARD LVCMOS18 } [get_ports setup_scl];
set_property -dict { PACKAGE_PIN J25 IOSTANDARD LVCMOS18 } [get_ports setup_sda];
set_property -dict { PACKAGE_PIN AP10 IOSTANDARD LVCMOS18 } [get_ports i2c_mux_rst_n];
set_property -dict { PACKAGE_PIN K23 IOSTANDARD LVCMOS18 } [get_ports clkgen_rst_n];

set_false_path -to [get_ports -filter {NAME=~setup_s*}]
set_false_path -from [get_ports -filter {NAME=~setup_s*}]
set_false_path -to [get_ports -filter {NAME=~i2c_mux_rst_n}]
set_false_path -to [get_ports -filter {NAME=~clkgen_rst_n}]

